#!/usr/local/bin/perl
#############################################################################
# Guest Book 98.1.0 Personal Version - Entry Processor
#
# [Eng/Unix/Perl5]
#
# Written by Ray Chan, 1998/07/12
#
# Copyright 1997,1998 All Right Reserved.
#############################################################################
#
# Perl Reunion 98
# http://www.ray.org.hk/perl/
# perl@ray.org.hk
#
#############################################################################
#
# This script is free for personal use only.
# Please register the script if you find it useful, if is free anyway.
#
#############################################################################
#
# Disclaimer
#
# By using the script(s), you are agree and understand that the writers
# are not responsible for any damages caused under any conditions due to the
# malfunction or bugs from the script(s). Please use at your own risk.
#
#############################################################################
#
# guestadd.pl - Entry Processor
#
#       This script is used to collect the form data from the web and then
#       add to the guest book database.
#
#############################################################################
#
# Setup Section
#
#############################################################################
# 
# $cfgpath
#	full and complete unix path to the configuration file

$cfgpath='/usr1/home/jujubar/html/_GB/gbkcfg.txt';

#############################################################################
# End of Setup Section
#############################################################################

require $cfgpath;
require 5;

&form_data;

$error=0;

$tip=$ENV{"REMOTE_HOST"};
$tdn=$ENV{"REMOTE_ADDR"};
$banuser=0;

if ($ipbarrier == 1){
	$tip=~s/\n//g;
	$tip=~s/\r//g;
	@itip=split(/\./,$tip);
	foreach $item (@ipfilter){
		@dtip=split(/\./,$item);
		$pass=0;
		$cntit=0;
		foreach $yo (@dtip){
			if ($yo ne '*' && $yo != $itip[$cntit]){
				$pass=1;
				break;
			}
			$cntit=$cntit+1;
		}
		if ($pass==0){
			$banuser=1;
			break;
		}
	}
}
if ($namebarrier == 1 && $banuser == 0){
        $tdn=~s/\n//g;
        $tdn=~s/\r//g;
        @itdn=split(/\./,$tdn);
        foreach $item (@namefilter){
                @dtdn=split(/\./,$item);
                $pass=0;
		$lendtdn=@dtdn;
		$lenitdn=@itdn;
                $temp=@dtdn;
		$temp1=@itdn;
		for ($y=1;$y<=$lendtdn;$y++){
			$temp=$temp-1;
			$temp1=$temp1-1;
			if ($dtdn[$temp] ne '*' && $dtdn[$temp] ne $itdn[$temp1]){
                                $pass=1;
                                break;
                        }
                }

                if ($pass==0){
			if ($lendtdn==$lenitdn){
				$banuser=1;
				break;
			}
			if ($lendtdn< $lenitdn && $dtdn[0] eq '*'){
	                        $banuser=1;
        	                break;
			}
                }
        }
}

if ($banuser==1){
       print "Content-type: text/html\n\n";
                open (HEAD, $headersrc);
                @DATA1=<HEAD>;
                close (HEAD);
                foreach $item (@DATA1){
                        print "$item\n";
                }

        print "<FONT SIZE=5>Guest Book Entry Error</FONT><P>";
        print "You are not allowed to make any entry to the database.<P>";

	$error=1;
}

if (($DATA{"name"} eq "" || $DATA{"email"} eq "" || $DATA{"msg"} eq "My Comments" || $DATA{"msg"} eq "") && $error ==0){
	print "Content-type: text/html\n\n";
		open (HEAD, $headersrc);
        	@DATA1=<HEAD>;
        	close (HEAD);
        	foreach $item (@DATA1){
        	        print "$item\n";
        	}

	print "<FONT SIZE=5>Guest Book Entry Error</FONT><P>";
}

if ($error==0){
if ($DATA{"name"} eq ""){
	print "NAME field is missed.<P>";
	$error=1;
}
if ($DATA{"email"} eq ""){
	print "EMail Address field is missed.<P>";
	$error=1;
}
if ($DATA{"msg"} eq "My Comments" || $DATA{"msg"} eq ""){
	print "Please enter your comments!<P>";
	$error=1;
}
}

if ($abuse > 0 && $error==0){
# check max char/word limit
	$temp=$DATA{'msg'};
	$temp=~ s/\n/ /g;
	$temp=~ s/\r/ /g;
	if ($abuse==1){ #count char
		@ccc=split(/[\t ]*/,$temp);
	}
	if ($abuse==2){ #count word
		@ccc=split(/[\t ]+/,$temp);
	}
	$cin=@ccc;
	if ($cin >$maxchar){
		$error=1;
	        print "Content-type: text/html\n\n";
                open (HEAD, $headersrc);
                @DATA1=<HEAD>;
                close (HEAD);
                foreach $item (@DATA1){
                        print "$item\n";
                }

	        print "<FONT SIZE=5>Guest Book Entry Error</FONT><P>";

		print "The length of the user comment exceed the default limit.";
		print "Please reduce the number of words or charcters.<P>";
	}
}

if ($error == 0){
if ($DATA{"preview"} eq "Yes"){
	print "Content-type: text/html\n\n";
	$Date=localtime();
	 open (HEAD, $header);
         @DATA1=<HEAD>;
         close (HEAD);
         foreach $item (@DATA1){
                print "$item\n";
         }
        
	$Date=localtime();

	if ($bold==1){
		print "<B>";
	}
	if ($replace == 1){
		#trim all html tag from comments!
		$DATA{'msg'} =~ s/<[^>]+>{1}//g;
	}
	if ($usepre ==1){
		print "<PRE>$DATA{'msg'}</PRE>";
		$DATA{'msg'} = "<PRE>".$DATA{'msg'}."</PRE>"; 	
	}
	if ($usepre ==0){
		$DATA{'msg'} =~ s/\cM\n/<br>\n/g;
		print "$DATA{'msg'}";
	}
	if ($bold==1){
		print "</B>";
	}
	print "<P><A HREF=\"mailto:$DATA{'email'}\">$DATA{'name'}</A>";
	if ($DATA{'place'} ne ""){
		print ", $DATA{'place'}";
	}
	if ($DATA{"url"} ne ""){
		if ($DATA{"www"} ne "" && $ontop==0){
		print " (<A HREF=\"$DATA{'url'}\">$DATA{'www'}</A>)";
		}
		if ($DATA{'www'} ne "" && $ontop==1){
		print " (<A HREF=\"$DATA{'url'}\"";
		print " TARGET=\"_top\">$DATA{'www'}</A>)";
		}
		if ($DATA{"www"} eq "" && $ontop==0){
		print " (<A HREF=\"$DATA{'url'}\">$DATA{'url'}</A>)";
		}
		if ($DATA{"www"} eq "" && $ontop==1){
		print " (<A HREF=\"$DATA{'url'}\"";
		print " TARGET=\"_top\">$DATA{'url'}</A>)";
		}
	}
	print "<BR>$Date";
	print "<HR>";
        print "<FORM ACTION=\"$scriptsrc\" METHOD=POST>";
	print "<INPUT TYPE=hidden NAME=preview VALUE=\"No\">";
	print "<INPUT TYPE=hidden NAME=name VALUE=\"$DATA{'name'}\">";
	print "<INPUT TYPE=hidden NAME=email VALUE=\"$DATA{'email'}\">";
	print "<INPUT TYPE=hidden NAME=place VALUE=\"$DATA{'place'}\">";
	print "<INPUT TYPE=hidden NAME=www VALUE=\"$DATA{'www'}\">";
        print "<INPUT TYPE=hidden NAME=url VALUE=\"$DATA{'url'}\">";
	$DATA{'msg'} =~ s/\"/'/g;
        print "<INPUT TYPE=hidden NAME=msg VALUE=\"$DATA{'msg'}\">";
	print "<INPUT TYPE=submit VALUE=\"Confirm Submit\">";
	print "</FORM>";
}

if ($DATA{"preview"} eq "No"){

        open (GBK, $guestsrc);
        @DATA1=<GBK>;
        close (GBK);

	#### page count function ####
	# count the total number of pages
	$count=0;

	foreach $rec (@DATA1){
        	if ($rec =~ /<NEWBIE>/){
                	$count++;
        	}
	}

	print "Content-type: text/html\n\n";

        open (HEAD, $headersrc);
	@DATA1=<HEAD>;
	close (HEAD);
	foreach $item (@DATA1){
		print "$item\n";
	}
        
	open (GBK, $guestsrc);
        @DATA1=<GBK>;
	close (GBK);

	open (GBK, ">$guestsrc");

	if ($addto == 1){
		if ($unlimit == 1){
                foreach $item (@DATA1){
        	        print GBK $item;
       	 	}}else{
			if ($count >= $max_entry){
				$edel=$count-$max_entry+1;
				$ec=1;
				foreach $item (@DATA1){
					if ($ec > $edel){
						print GBK $item;
					}
					if ($item=~/<NEWBIE>/){
						$ec=$ec+1;
					}
				}
			}else{
				foreach $item (@DATA1){
					print GBK $item;
				}
			}
		}
	}
	if ($bold==1){
		print GBK "<B>";
	}
	print GBK $DATA{"msg"};
	if ($bold==1){
		print GBK "</B>\n";
	}
        print GBK "<P><A HREF=\"mailto:$DATA{'email'}\">$DATA{'name'}</A>";

	if ($DATA{"place"} ne ""){
		print GBK ", $DATA{'place'}";
	}
	$Date=localtime();
	if ($DATA{"url"} ne ""){
                if ($DATA{"www"} ne "" && $ontop==0){
                print GBK " (<A HREF=\"$DATA{'url'}\">$DATA{'www'}</A>)";
                }
                if ($DATA{'www'} ne "" && $ontop==1){
                print GBK " (<A HREF=\"$DATA{'url'}\"";
		print GBK " TARGET=\"_top\">$DATA{'www'}</A>)";
                }   
                if ($DATA{"www"} eq "" && $ontop==0){
                print GBK " (<A HREF=\"$DATA{'url'}\">$DATA{'url'}</A>)";
                }
                if ($DATA{"www"} eq "" && $ontop==1){
                print GBK " (<A HREF=\"$DATA{'url'}\"";
		print GBK " TARGET=\"_top\">$DATA{'url'}</A>)";
                }    
	}
	print GBK "<BR>$Date";
	print GBK "\n<NEWBIE>\n";

	if ($addto == 0){
		if ($unlimit == 1){
                foreach $item (@DATA1){
			print GBK $item;
		}}else{
			if ($count >= $max_entry){
				$edel=$max_entry-1;
        			$ec=1;
        			foreach $item (@DATA1){
                			if ($ec <= $edel){
                        			print GBK $item;
                			}
			                if ($item=~/<NEWBIE>/){
                        			$ec=$ec+1;
                			}
				}
			}else{
        			foreach $item (@DATA1){
                			print GBK $item;
				}
			}
		}
	}
	close (GBK);
	$temp=0;
	$stop=0;
	$more=0;
	$max=$entryno;

	#print the first page entry

	open (GBK, $guestsrc);
        @DATA1=<GBK>;
	close (GBK);
        foreach $item (@DATA1){
	        chop($item);
	        if ($stop == 1){
        	        $more=1;
                	break;
        	}
        	if ($temp <=$max -1){
                	print $item;
		}
        	if ($item eq "<NEWBIE>"){
                	if ($temp <=$max-1){
                        	print "<HR>";
                	}
                	$temp++;
                	if ($temp >= $max){
                	        $stop=1;
                	}
        	} 
	}
	if ($ontop1==0){
	        print "Back to <A HREF=\"$backurl\">Home</A><P>";
	}
	if ($ontop1==1){
		 print "Back to <A HREF=\"$backurl\" TARGET=\"_top\">Home</A><P>";
	}


        #### page count function ####
        # count the total number of pages
        $count=0;
                                         
        foreach $rec (@DATA1){
                if ($rec =~ /<NEWBIE>/){
                        $count++;
                }
        }

        $maxpage=int($count/$entryno);

        if ($count/$entryno != int($count/$entryno)){
                $maxpage++;
        }

        if ($maxpage < 1){
                $maxpage=1;
        }

	&bar(1,$maxpage);

#	if ($more == 0){
#		print "<CENTER>[Previous| Page 1 of $maxpage |Next]</CENTER>";
#	}
#	if ($more == 1){
#		print "<CENTER>[Previous| Page 1 of $maxpage |";
#                print "<A HREF=\"$booksrc?2\">Next</A>]</CENTER>";
#	}

	#send notification message
	if ($notify == 1){
		open (MAIL, "|$mail $from");
                print MAIL "From: Guest Book 0.7\n";
		print MAIL "To: $from\n";
		print MAIL "Subject: New Guest Book Entry\n\n";
		print MAIL "You have a new book entry!!\n\n";
		print MAIL "From: $DATA{'name'}\n";
		print MAIL "Mail: $DATA{'email'}\n";
		print MAIL "Site: $DATA{'www'}\n";
		print MAIL "URL : $DATA{'url'}\n";
		close (MAIL);
	}

	#send greeting message

	#first check for a valid email address
        if ($greeting == 1){
		if ($DATA{'email'} =~ /.+@.+\..+/){
                open (MAIL, "|$mail $DATA{'email'}");
                print MAIL "From: Guest Book 0.7\n";
                print MAIL "To: $DATA{'email'}\n";
                print MAIL "Subject: Your Guest Book Entry\n\n";
		print MAIL "Thanks for your entry to my guest book!\n";
		print MAIL "\nHere are what you submit:\n";
		print MAIL "--------------------------------------\n";
                print MAIL "From: $DATA{'name'}\n";
                print MAIL "Mail: $DATA{'email'}\n";
                print MAIL "Site: $DATA{'www'}\n";
                print MAIL "URL : $DATA{'url'}\n";
		print MAIL "\nPlease visit us again soon!\n";
                close (MAIL);
		}
        }
}
	
}
print "</BODY></HTML>";

sub form_data {
     read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

      @pairs = split(/&/, $buffer);
  foreach $pair (@pairs) {
      ($name, $value) = split(/=/, $pair);

      $name =~ tr/+/ /;
      $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;

      $value =~ tr/+/ /;
      $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
      $value =~ s/<!--(.|\n)*-->//g;
      $DATA{$name} = $value;

	#remove bad words from user comments
	if ($censoring == 1){
		foreach $item (@badwords){
			$DATA{'msg'}=~s/$item//g
		}
	}
  }
} 

sub bar{
        local ($i)=0;
        $curr_page=$_[0];
        $max_page=$_[1];
        $first=int($curr_page/10)*10+1;
        $last=$first+9;
        if ($curr_page < $first){
                $first=$first-10;
                $last=$last-10;
        }
        if ($last > $max_page){
                $last=$max_page;
        }
        print "<P><CENTER>[";

        if ($first > 1){
                $prev_page=$first-1;
                $pi=$prev_page-9;
                print <<EOF;
		<A HREF="$booksrc?$prev_page" onmouseover="window.status='Go to previous section page $prev_page';return true">$pi - $prev_page</A> |
EOF
	}
        for($i=$first;$i<=$last;$i++){
                if ($i != $curr_page){
                print<<EOF;
		<A HREF="$booksrc?$i" onmouseover="window.status='Go to guestbook page $i';return true">$i</A>
EOF
                }else{
                        print "&nbsp;$i&nbsp;";
                }
                if ($i<$last){
                        print "|";
                }
        }

        if ($last < $max_page){
                $next_page=$last+1;
                $pi = $next_page+9;
                print <<EOF;
                |
		<A HREF="$booksrc?$next_page" onmouseover="window.status='Go to next section page $next_page';return true">$next_page - $pi</A>
EOF
        }
        print "]</CENTER>";
}

